package pay

import (
	"github.com/gin-gonic/gin"
	"system_pay/controller/base"
	"system_pay/models"
	"system_pay/repository/pay"
)

// 卡拉卡统一支付回调
type NoticeController struct {
}

// WxNotice 拉卡拉统一支付微信回调
// @Summary 拉卡拉统一支付微信回调
// @Description 拉卡拉统一支付微信回调
// @Tags 拉卡拉统一支付回调
// @Accept application/json
// @Produce application/json
// @Param language header string ture "语言类型 zh-CN简体中文 en-US英文 ja 日文 默认中文"
// @Success 200
// @router /api/v1/pay/wx_notice [post]
func (l *PayController) WxNotice(c *gin.Context) {

	ph := new(models.WxNoticeInput)
	err := c.ShouldBind(ph)
	if err != nil {
		response := new(base.ResponseDataWxNotice)
		response.Code = "FAIL"
		response.Message = "执行失败"
		base.ResponseWxNotice(c, response)
		return
	}

	// 拉卡拉统一支付微信回调
	response, err := pay.WxNotice(ph)
	base.ResponseWxNotice(c, response)
}
