package models

// WxNoticeInput 微信回调输入参数
type WxNoticeInput struct {
	ChannelId          uint8   `json:"channel_id" description:"平台类型 1: saas  2: shop 3: shop mobile 4: 收银台"`
	MerchantNo         string  `json:"merchant_no" description:"平台信息"`
	OrderCreateTime    string  `json:"order_create_time" description:"商品描述"`
	OrderEfficientTime string  `json:"order_efficient_time" description:"商品详情"`
	OrderInfo          string  `json:"order_info" description:"附加信息"`
	OrderStatus        float64 `json:"order_status" description:"商品金额,个位为分"`
	OutOrderNo         string  `json:"out_order_no" description:"客户端回调的url"`
	PayOrderNo         int     `json:"pay_order_no" description:"1: 微信，2: 支付宝, 3: 拉卡拉 4: 收钱吧"`
	TermNo             uint8   `json:"term_no" description:"1: 微信 Native  2：微信小程序  3：微信内支付 4：h5 跳微信 5：支付宝(web)-扫码或登录支付宝账户  6：alipay(mobile) 7：alipay(app) 9: B2C 10:bk支付宝web 11:bk 支付宝手机"`
	TotalAmount        string  `json:"total_amount" description:"此参数 支付类型是 JS API 的时候 必传"`
	TransMerchantNo    string  `json:"trans_merchant_no" description:"WAP网站URL地址, 支付方式为微信MWEB时 必传"`
	TransTermNo        string  `json:"trans_term_no" description:"WAP网站名称, 支付方式为微信MWEB时 必传"`
}

// CallbackResponse is 回调给业务方的信息
type CallbackResponse struct {
	OutTradeNo    string `json:"out_trade_no"`   // 订单号
	ReturnMsg     string `json:"return_msg"`     // 是否成功
	AttachInfo    string `json:"attach_info"`    // 附加信息
	TransactionID string `json:"transaction_id"` // 微信支付订单号
	TradeNo       string `json:"trade_no"`       // 支付宝交易流水号
}
